@ECHO OFF
ECHO F؃L[擾
wget -O myplayer-release.swf http://radiko.jp/apps/js/flash/myplayer-release.swf
swfextract -b 12 myplayer-release.swf -o authkey.jpg
ECHO F؃g[N擾
wget -O auth1_fms ^
	--header="pragma: no-cache" ^
	--header="X-Radiko-App: pc_ts" ^
	--header="X-Radiko-App-Version: 4.0.0" ^
	--header="X-Radiko-User: test-stream" ^
	--header="X-Radiko-Device: pc" ^
	--post-data='\r\n' ^
	--no-check-certificate ^
	--save-headers ^
	https://radiko.jp/v2/api/auth1_fms
FOR /F "usebackq tokens=1,2 delims=: " %%I IN (auth1_fms) DO (
	IF "%%~I"=="X-Radiko-AuthToken" SET AUTHTOKEN=%%~J
	IF "%%~I"=="X-Radiko-KeyLength" SET KEYLENGTH=%%~J
	IF "%%~I"=="X-Radiko-KeyOffset" SET KEYOFFSET=%%~J
)
ECHO F؃L[o
dd if=authkey.jpg bs=1 skip=%KEYOFFSET% count=%KEYLENGTH% of=partialkey.bin
certutil -f -encode partialkey.bin partialkey.txt
FOR /F "usebackq eol=- delims=" %%I IN (partialkey.txt) DO SET PARTIALKEY=%%~I
ECHO F؏
wget -O auth2_fms ^
	--header="pragma: no-cache" ^
	--header="X-Radiko-App: pc_ts" ^
	--header="X-Radiko-App-Version: 4.0.0" ^
	--header="X-Radiko-User: test-stream" ^
	--header="X-Radiko-Device: pc" ^
	--header="X-Radiko-Authtoken: %AUTHTOKEN%" ^
	--header="X-Radiko-Partialkey: %PARTIALKEY%" ^
	--post-data='\r\n' ^
	--no-check-certificate ^
	https://radiko.jp/v2/api/auth2_fms
ECHO GAID擾
FOR /F "usebackq tokens=1 delims=," %%I IN (auth2_fms) DO SET AREA_ID=%%~I
ECHO ݓt̓擾
SET NOWDATE="%DATE%"
SET /A YY=1%NOWDATE:~1,4%-10000
SET /A MM=1%NOWDATE:~6,2%-100
SET /A DD=1%NOWDATE:~9,2%-100
IF %MM% LSS 3 (
	SET /A YY=%YY%-1
	SET /A MM=%MM%+12
)
SET /A NOWDAYS=%YY%*365+%YY%/4-%YY%/100+%YY%/400+(%MM%-3)/5*153+(%MM%-3)%%5/2*61+(%MM%-3)%%5%%2*31+%DD%-306
ECHO 1TԑO̓擾
SET /A EPGDAYS=%NOWDAYS%-7
:LOOP
ECHO NAAɕϊ
SET /A Y400Q=(%EPGDAYS%+305)/146097
SET /A Y400R=(%EPGDAYS%+305)%%146097
SET /A Y100Q=%Y400R%/36524
SET /A Y100R=%Y400R%%%36524
SET /A Y4Q=%Y100R%/1461
SET /A Y4R=%Y100R%%%1461
SET /A Y1Q=%Y4R%/365
SET /A Y1R=%Y4R%%%365
SET /A D5R=(%Y1R%+%Y100Q%/4*365+%Y1Q%/4*365)/153
SET /A D5Q=(%Y1R%+%Y100Q%/4*365+%Y1Q%/4*365)%%153
SET /A D2R=%D5Q%/61
SET /A D2Q=%D5Q%%%61
SET /A D1R=%D2Q%/31
SET /A D1Q=%D2Q%%%31
SET /A YY=%Y400Q%*400+%Y100Q%*100-%Y100Q%/4+%Y4Q%*4+%Y1Q%-%Y1Q%/4
SET /A MM=%D5R%*5+%D2R%*2+%D1R%+3
SET /A DD=%D1Q%+1
IF %MM% GTR 12 (
	SET /A YY=%YY%+1
	SET /A MM=%MM%-12
)
SET YY=0000%YY%
SET MM=00%MM%
SET DD=00%DD%
ECHO ԑg\擾
wget -O program.xml http://radiko.jp/v3/program/date/%YY:~-4%%MM:~-2%%DD:~-2%/%AREA_ID%.xml
ECHO CSVϊ
nkf -Lw program.xml ^
	| sed -n -e "/<station /h;/<prog /{N;G;s/\n//gp}" ^
	| sed -e "s/,/C/g;s/[^<]*<prog[^>]* ft=//;s/ to=/,/;s/ ftl=[^>]*>[^<]*<title>/,/;s/<\/title>[^<]*<station id=/,/;s/>.*//" ^
	| sed -e "s/&amp;//g;s/&quot;/h/g;s/&lt//g;s/&gt//g;s/&#39;/'/g" ^
	| sed -e "y/\\\/:*?<>|/^FHb/" ^
	> program.csv
ECHO L[[h
FIND "%~1" < program.csv > program.txt
IF EXIST "%~dpn0.ini" (
	FOR /F "usebackq delims=" %%I IN ("%~dpn0.ini") DO (
		FIND "%%~I" < program.csv >> program.txt
	)
)
ECHO ^
FOR /F "usebackq tokens=1-4 delims=," %%I IN (program.txt) DO (
	wget -O playlist.m3u8 ^
		--header="pragma: no-cache" ^
		--header="Content-Type: application/x-www-form-urlencoded" ^
		--header="X-Radiko-Authtoken: %AUTHTOKEN%" ^
		--header="Referer: http://radiko.jp/apps/js/flash/myplayer-release.swf" ^
		--post-data='flash=1' ^
		--no-check-certificate ^
		"https://radiko.jp/v2/api/ts/playlist.m3u8?l=15&station_id=%%~L&ft=%%~I&to=%%~J"
	FOR /F "usebackq tokens=1,2 delims=:" %%M IN (playlist.m3u8) DO (
		IF "%%~M"=="https" (
			ffmpeg -headers "X-Radiko-Authtoken: %AUTHTOKEN%" -i %%~M:%%~N -vn -acodec copy -bsf aac_adtstoasc "%%~I-%%~J-%%~L-%%~K.m4a"
		)
		IF "%%~M"=="http" (
			ffmpeg -headers "X-Radiko-Authtoken: %AUTHTOKEN%" -i %%~M:%%~N -vn -acodec copy -bsf aac_adtstoasc "%%~I-%%~J-%%~L-%%~K.m4a"
		)
	)
)
ECHO i߂ČݓŖΌJԂ
SET /A EPGDAYS=%EPGDAYS%+1
IF %EPGDAYS% NEQ %NOWDAYS% GOTO LOOP
EXIT /B
